package connection

import (
	"testing"
	"time"

	omd "git.loafle.net/overflow/model/discovery"
	"git.loafle.net/overflow_scanner/probe/__test"
	"git.loafle.net/overflow_scanner/probe/discovery/session"
	"git.loafle.net/overflow_scanner/probe/discovery/types"
)

func TestScan(t *testing.T) {
	s := session.NewMockDiscoverySession(
		"testRequester",
		types.DiscoveryRequestTypeHost,
		__test.Zone(),
		__test.DiscoverHost(
			__test.DiscoveryConfig(),
			1,
			254,
			__test.DiscoverPort(
				nil,
				1,
				65535,
				true,
				false,
				nil,
			),
		),
	)

	targetHost := __test.Host(
		"atGame",
		"1",
		"00:11:32:7f:20:61",
	)

	type args struct {
		discoverySession session.DiscoverySession
		targetHost       *omd.Host
	}
	tests := []struct {
		name    string
		args    args
		wantErr bool
	}{
		{
			name: "1",
			args: args{
				discoverySession: s,
				targetHost:       targetHost,
			},
			wantErr: false,
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if err := Scan(tt.args.discoverySession, tt.args.targetHost); (err != nil) != tt.wantErr {
				t.Errorf("Scan() error = %v, wantErr %v", err, tt.wantErr)
			}
		})
	}
}

func Test_scanPort(t *testing.T) {
	type args struct {
		discoverySession session.DiscoverySession
		ports            map[int]*omd.Port
		targetHost       *omd.Host
		port             int
		timeout          time.Duration
	}
	tests := []struct {
		name string
		args args
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			tryConnect(tt.args.discoverySession, tt.args.ports, tt.args.targetHost, tt.args.port, tt.args.timeout)
		})
	}
}

func TestUlimit(t *testing.T) {
	tests := []struct {
		name string
		want int64
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if got := Ulimit(); got != tt.want {
				t.Errorf("Ulimit() = %v, want %v", got, tt.want)
			}
		})
	}
}
