package types

func NewMockDiscoveryMessage(request DiscoveryRequest, messageType DiscoveryMessageType, data interface{}, err error) DiscoveryMessage {
	return &MockDiscoveryMessage{
		request:     request,
		messageType: messageType,
		data:        data,
		err:         err,
	}
}

type MockDiscoveryMessage struct {
	request     DiscoveryRequest
	messageType DiscoveryMessageType
	data        interface{}
	err         error
}

func (dm *MockDiscoveryMessage) Request() DiscoveryRequest {
	return dm.request
}

func (dm *MockDiscoveryMessage) Type() DiscoveryMessageType {
	return dm.messageType
}

func (dm *MockDiscoveryMessage) Data() interface{} {
	return dm.data
}

func (dm *MockDiscoveryMessage) Error() error {
	return dm.err
}

func (dm *MockDiscoveryMessage) Release() {
}

func NewMockDiscoveryRequest(requesterID string, requestType DiscoveryRequestType, params ...interface{}) DiscoveryRequest {
	return &MockDiscoveryRequest{
		requesterID: requesterID,
		requestType: requestType,
		params:      params,
	}
}

type MockDiscoveryRequest struct {
	requesterID string
	requestType DiscoveryRequestType
	params      []interface{}
}

func (dr *MockDiscoveryRequest) RequesterID() string {
	return dr.requesterID
}

func (dr *MockDiscoveryRequest) RequestType() DiscoveryRequestType {
	return dr.requestType
}

func (dr *MockDiscoveryRequest) Params() []interface{} {
	return dr.params
}
