package service

import (
	"reflect"

	oa "git.loafle.net/overflow/annotation-go"
	od "git.loafle.net/overflow/di-go"
	omn "git.loafle.net/overflow/model/net"
	"git.loafle.net/overflow_scanner/probe/nic"
)

func init() {
	od.RegisterType(MachineServiceType)
}

var MachineServiceType = reflect.TypeOf((*MachineService)(nil))

type MachineService struct {
	oa.TypeAnnotation `annotation:"@Injectable('name': 'MachineService') @Service()"`

	_InitService    oa.MethodAnnotation `annotation:"@PostConstruct()"`
	_DestroyService oa.MethodAnnotation `annotation:"@PreDestroy()"`
}

func (s *MachineService) InitService() {

}

func (s *MachineService) DestroyService() {

}

func (s *MachineService) Interfaces() ([]*omn.Interface, error) {
	return nic.DiscoverInterfaces()
}
